
#property copyright "ForexCrush"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern int showBars = 3000;
extern int LevDP = 2;
extern int qSteps = 1;
extern int BackStep = 0;
extern int startBar = 0;
extern bool TrendLine = FALSE;
extern bool HorizontLine = FALSE;
extern bool ChannelLine = FALSE;
extern bool TakeLines = FALSE;
extern bool Comments = FALSE;
extern int Trend = 0;
extern bool ShowArrows = TRUE;
extern bool CustomFeatures = TRUE;
extern color UpTrendColor = Green;
extern color DownTrendColor = Red;
extern int TrendlineWidth = 3;
extern bool ShowAlerts = FALSE;
extern bool EmailAlert = FALSE;
int g_width_148;
color g_color_152;
double g_ibuf_156[];
double g_ibuf_160[];
int gi_164 = 10;
double g_ibuf_168[];
double g_ibuf_172[];
string gsa_176[] = {"Red", "DarkBlue", "Coral", "DodgerBlue", "SaddleBrown", "MediumSeaGreen"};
int gia_180[] = {255, 16760576, 5275647, 16776960, 1262987, 7451452};
int gi_184 = 0;
int g_bars_188;
double g_time_192 = 0.0;
int gi_200;
int gi_204;

int init() {
   IndicatorBuffers(4);
   g_bars_188 = Bars;
   qSteps = MathMin(3, qSteps);
   while (NormalizeDouble(Point, gi_184) == 0.0) gi_184++;
   int li_0 = 161;
   string ls_4 = "DLines  GameOver";
   IndicatorShortName(ls_4);
   if (ShowArrows) {
      SetIndexStyle(0, DRAW_ARROW);
      SetIndexStyle(1, DRAW_ARROW);
   }
   SetIndexArrow(0, li_0);
   SetIndexArrow(1, li_0);
   SetIndexBuffer(0, g_ibuf_156);
   SetIndexBuffer(1, g_ibuf_160);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexLabel(0, ls_4);
   SetIndexLabel(1, ls_4);
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(2, SYMBOL_ARROWUP);
   SetIndexBuffer(2, g_ibuf_168);
   SetIndexStyle(3, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(3, SYMBOL_ARROWDOWN);
   SetIndexBuffer(3, g_ibuf_172);
   return (0);
}

int deinit() {
   ObjectsDeleteAll();
   Comment("");
   ArrayInitialize(g_ibuf_156, 0.0);
   ArrayInitialize(g_ibuf_160, 0.0);
   for (int li_0 = 1; li_0 <= LevDP; li_0++) {
      ObjectDelete("HA_" + li_0);
      ObjectDelete("LA_" + li_0);
      ObjectDelete("HL_" + li_0);
      ObjectDelete("LL_" + li_0);
      ObjectDelete("HHL_" + li_0);
      ObjectDelete("HLL_" + li_0);
      ObjectDelete("HCL_" + li_0);
      ObjectDelete("LCL_" + li_0);
      for (int l_count_4 = 0; l_count_4 < 4; l_count_4++) {
         ObjectDelete("HTL_" + li_0 + l_count_4);
         ObjectDelete("LTL_" + li_0 + l_count_4);
      }
   }
   return (0);
}

int start() {
   string ls_4;
   if (g_bars_188 != Bars) {
      deinit();
      Sleep(1000);
      g_bars_188 = Bars;
      g_time_192 = 0;
      return (0);
   }
   if (g_time_192 == Time[0]) return (0);
   g_time_192 = Time[0];
   if (showBars == 0) showBars = Bars - LevDP;
   for (int li_0 = showBars; li_0 > LevDP; li_0--) {
      g_ibuf_156[li_0] = DemHigh(li_0, LevDP);
      g_ibuf_160[li_0] = DemLow(li_0, LevDP);
   }
   int li_20 = Time[0] + 60 * Period() - TimeCurrent();
   double ld_12 = li_20 / 60.0;
   int li_24 = li_20 % 60;
   li_20 = (li_20 - li_20 % 60) / 60;
   ls_4 = ls_4 + "Demark with alerts";
   ls_4 = ls_4 + (li_20 + " minutes " + li_24 + " seconds left to bar end") 
   + "\n";
   if (Comments) Comment(ls_4);
   else {
      Comment("Demark with alerts" 
         + "\n" 
         + li_20 + " minutes " + li_24 + " seconds left to bar end" 
      + "\n");
   }
   ls_4 = ls_4 + "Trend Line[" + On(TrendLine) + "]; Channel [" + On(ChannelLine) + "]; Breakout level [" + On(HorizontLine) + "]; Targets [" + On(TakeLines) + "]\n";
   for (li_0 = 1; li_0 <= qSteps; li_0++) ls_4 = ls_4 + TDMain(li_0);
   ls_4 = ls_4 + "  GameOver ";
   if (Comments == TRUE) Comment(ls_4);
   return (0);
}

string TDMain(int ai_0) {
   int li_4;
   int li_8;
   int li_12;
   int li_16;
   int li_20;
   int l_index_24;
   color l_color_28;
   double ld_32;
   double ld_40;
   double ld_48;
   double lda_56[4];
   double lda_60[4];
   bool li_64;
   string ls_76;
   string l_name_84;
   string ls_92;
   string ls_ret_68 = " Step " + ai_0 + " of " + qSteps + " (BackStep " + BackStep + ")\n";
   if (Trend <= 0) {
      ls_ret_68 = ls_ret_68 + " " + ((gsa_176[ai_0 << 1 - 2])) + " DownTrendLine ";
      l_color_28 = gia_180[ai_0 << 1 - 2];
      li_4 = GetTD(ai_0 + BackStep, g_ibuf_156);
      li_8 = GetNextHighTD(li_4);
      ld_40 = (High[li_8] - High[li_4]) / (li_8 - li_4);
      li_20 = iLowest(NULL, 0, MODE_LOW, li_8 - li_4 - 1, li_4 + 1);
      ld_48 = High[li_8] - ld_40 * li_8;
      if (ai_0 + BackStep == 1) ld_48 -= ld_40 * startBar;
      if (li_4 < 0 || li_8 < 0) ls_ret_68 = ls_ret_68 + "not enough points on the chart for construction\n";
      else {
         ls_ret_68 = ls_ret_68 + "[" + DoubleToStr(High[li_8], gi_184) + "" + DoubleToStr(High[li_4], gi_184) + "]";
         ls_ret_68 = ls_ret_68 + "; Level " + DoubleToStr(ld_48, gi_184);
         if (ai_0 + BackStep == 1) {
            if (startBar > 0) ls_ret_68 = ls_ret_68 + "; Future Bar " + UpHitch(-1, ld_48);
            else ls_ret_68 = ls_ret_68 + "; Last Bar " + UpHitch(startBar, ld_48);
         }
         ls_ret_68 = ls_ret_68 
         + "\n";
         l_index_24 = li_4;
         li_64 = FALSE;
         ls_76 = "";
         while (l_index_24 > 0 && li_64 == FALSE) {
            g_ibuf_168[l_index_24] = 0;
            ld_32 = High[li_8] - ld_40 * (li_8 - l_index_24);
            l_name_84 = "HA_" + ai_0;
            if (Close[l_index_24] > ld_32) {
               ls_92 = UpHitch(l_index_24, ld_32);
               if (ls_92 != "") {
                  li_64 = TRUE;
                  ls_76 = ls_76 + "Source " + DoubleToStr(ld_32, gi_184) + " " + ls_92;
                  g_ibuf_168[l_index_24] = Low[l_index_24] - gi_164 * Point;
                  if (gi_200 != Time[l_index_24]) {
                     if (ShowAlerts) Alert("MOUTEKI: Upper trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid);
                     ObjectCreate(l_name_84, OBJ_ARROW, 0, 0, 0, 0, 0);
                     ObjectSet(l_name_84, OBJPROP_COLOR, l_color_28);
                     ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                     ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                     ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
                     if (EmailAlert) {
                        SendMail("MOUTEKI: Upper trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid, "MOUTEKI: Upper trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid 
                           + "\n" 
                        + "Alerts by LightKeeper. martkoz@optusnet.com.au");
                     }
                     gi_200 = Time[l_index_24];
                  }
                  ObjectCreate(l_name_84, OBJ_ARROW, 0, 0, 0, 0, 0);
                  ObjectSet(l_name_84, OBJPROP_COLOR, l_color_28);
                  ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                  ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                  ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
                  if (ShowArrows == TRUE) {
                     while (l_index_24 > 0) {
                        l_index_24--;
                        if (Low[l_index_24] < Low[li_20] || Close[l_index_24] < Low[li_20] + 0.236 * (High[li_4] - Low[li_20])) {
                           ls_76 = ls_76 + " (cancel)";
                           ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                           ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                           ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
                           break;
                        }
                     }
                  }
               } else {
                  ls_76 = ls_76 + "False " + DoubleToStr(ld_32, gi_184) + "; ";
                  ObjectDelete(l_name_84);
               }
            }
            l_index_24--;
         }
         if (ls_76 == "") ls_76 = "No breakout";
         ls_ret_68 = ls_ret_68 + ls_76 
         + "\n";
         l_name_84 = "HL_" + ai_0;
         if (CustomFeatures) g_color_152 = DownTrendColor;
         else g_color_152 = l_color_28;
         if (TrendLine) {
            if (CustomFeatures == FALSE) g_width_148 = 3 - MathMin(2, ai_0);
            else g_width_148 = TrendlineWidth;
            ObjectCreate(l_name_84, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_TIME1, Time[li_8]);
            ObjectSet(l_name_84, OBJPROP_TIME2, Time[li_4]);
            ObjectSet(l_name_84, OBJPROP_PRICE1, High[li_8]);
            ObjectSet(l_name_84, OBJPROP_PRICE2, High[li_4]);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
            ObjectSet(l_name_84, OBJPROP_WIDTH, g_width_148);
         } else ObjectDelete(l_name_84);
         l_name_84 = "HHL_" + ai_0;
         if (HorizontLine && ai_0 + BackStep == 1) {
            ObjectCreate(l_name_84, OBJ_HLINE, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_PRICE1, ld_48);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
         } else ObjectDelete(l_name_84);
         l_name_84 = "HCL_" + ai_0;
         if (ChannelLine) {
            ObjectCreate(l_name_84, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_TIME1, Time[li_20]);
            ObjectSet(l_name_84, OBJPROP_TIME2, Time[0]);
            ObjectSet(l_name_84, OBJPROP_PRICE1, Low[li_20]);
            ObjectSet(l_name_84, OBJPROP_PRICE2, Low[li_20] - ld_40 * li_20);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
         } else ObjectDelete(l_name_84);
         l_name_84 = "HTL_" + ai_0;
         if (TakeLines) {
            lda_56[3] = Low[li_20] + 1.618 * (High[li_4] - Low[li_20]) - ld_48;
            lda_56[0] = High[li_8] - ld_40 * (li_8 - li_20) - Low[li_20];
            lda_56[1] = High[li_8] - ld_40 * (li_8 - li_20) - Close[li_20];
            li_20 = iLowest(NULL, 0, MODE_CLOSE, li_8 - li_4, li_4);
            lda_56[2] = High[li_8] - ld_40 * (li_8 - li_20) - Close[li_20];
            ls_ret_68 = ls_ret_68 + "Targets: ";
            for (l_index_24 = 0; l_index_24 < 4; l_index_24++) {
               ld_40 = NormalizeDouble(ld_48 + lda_56[l_index_24], gi_184);
               ObjectCreate(l_name_84 + l_index_24, OBJ_HLINE, 0, 0, 0, 0, 0);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_PRICE1, ld_40);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_STYLE, STYLE_DOT);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_COLOR, g_color_152);
               ls_ret_68 = ls_ret_68 + DoubleToStr(ld_40, gi_184) + " (" + DoubleToStr(lda_56[l_index_24] / Point, 0) + "p.) ";
            }
            ls_ret_68 = ls_ret_68 
            + "\n";
         } else for (l_index_24 = 0; l_index_24 < 4; l_index_24++) ObjectDelete(l_name_84 + l_index_24);
      }
   }
   if (Trend >= 0) {
      ls_ret_68 = ls_ret_68 + " " + ((gsa_176[ai_0 << 1 - 1])) + " UpTrendLine ";
      l_color_28 = gia_180[ai_0 << 1 - 1];
      li_12 = GetTD(ai_0 + BackStep, g_ibuf_160);
      li_16 = GetNextLowTD(li_12);
      ld_40 = (Low[li_12] - Low[li_16]) / (li_16 - li_12);
      li_20 = iHighest(NULL, 0, MODE_HIGH, li_16 - li_12 - 1, li_12 + 1);
      ld_48 = Low[li_16] + ld_40 * li_16;
      if (ai_0 + BackStep == 1) ld_48 += ld_40 * startBar;
      if (li_12 < 0 || li_16 < 0) ls_ret_68 = ls_ret_68 + "not enough points on the chart for construction\n";
      else {
         ls_ret_68 = ls_ret_68 + "[" + DoubleToStr(Low[li_16], gi_184) + "" + DoubleToStr(Low[li_12], gi_184) + "]";
         ls_ret_68 = ls_ret_68 + "; Level " + DoubleToStr(ld_48, gi_184);
         if (ai_0 + BackStep == 1) {
            if (startBar > 0) ls_ret_68 = ls_ret_68 + "; Future Bar " + DownHitch(-1, ld_48);
            else ls_ret_68 = ls_ret_68 + "; Last Bar " + DownHitch(startBar, ld_48);
         }
         ls_ret_68 = ls_ret_68 
         + "\n";
         l_index_24 = li_12;
         li_64 = FALSE;
         ls_76 = "";
         while (l_index_24 > 0 && li_64 == FALSE) {
            g_ibuf_172[l_index_24] = 0;
            ld_32 = Low[li_16] + ld_40 * (li_16 - l_index_24);
            l_name_84 = "LA_" + ai_0;
            if (Close[l_index_24] < ld_32) {
               ls_92 = DownHitch(l_index_24, ld_32);
               if (ls_92 != "") {
                  li_64 = TRUE;
                  ls_76 = ls_76 + "Source " + DoubleToStr(ld_32, gi_184) + " " + ls_92;
                  g_ibuf_172[l_index_24] = High[l_index_24] + gi_164 * Point;
                  if (gi_204 != Time[l_index_24]) {
                     if (ShowAlerts) Alert("MOUTEKI: Lower trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid);
                     ObjectCreate(l_name_84, OBJ_ARROW, 0, 0, 0, 0, 0);
                     ObjectSet(l_name_84, OBJPROP_COLOR, l_color_28);
                     ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                     ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                     ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
                     if (EmailAlert) {
                        SendMail("MOUTEKI: Lower trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid, "MOUTEKI: Lower trendline broken on " + Symbol() + " TF: " + Period() + " @ " + Bid 
                           + "\n" 
                        + "Alerts by LightKeeper. martkoz@optusnet.com.au");
                     }
                     gi_204 = Time[l_index_24];
                  }
                  ObjectCreate(l_name_84, OBJ_ARROW, 0, 0, 0, 0, 0);
                  ObjectSet(l_name_84, OBJPROP_COLOR, l_color_28);
                  ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                  ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                  ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
                  if (ShowArrows == TRUE) {
                     while (l_index_24 > 0) {
                        l_index_24--;
                        if (High[l_index_24] > High[li_20] || Close[l_index_24] > High[li_20] - 0.236 * (High[li_20] - Low[li_12])) {
                           ls_76 = ls_76 + " (cancel)";
                           ObjectSet(l_name_84, OBJPROP_PRICE1, Low[l_index_24] - Point);
                           ObjectSet(l_name_84, OBJPROP_TIME1, Time[l_index_24]);
                           ObjectSet(l_name_84, OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
                           break;
                        }
                     }
                  }
               } else {
                  ls_76 = ls_76 + "False " + DoubleToStr(ld_32, gi_184) + "; ";
                  ObjectDelete(l_name_84);
               }
            }
            l_index_24--;
         }
         if (ls_76 == "") ls_76 = "No breakout";
         ls_ret_68 = ls_ret_68 + ls_76 
         + "\n";
         l_name_84 = "LL_" + ai_0;
         if (CustomFeatures) g_color_152 = UpTrendColor;
         else g_color_152 = l_color_28;
         if (TrendLine == TRUE) {
            if (CustomFeatures == FALSE) g_width_148 = 3 - MathMin(2, ai_0);
            else g_width_148 = TrendlineWidth;
            ObjectCreate(l_name_84, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_TIME1, Time[li_16]);
            ObjectSet(l_name_84, OBJPROP_TIME2, Time[li_12]);
            ObjectSet(l_name_84, OBJPROP_PRICE1, Low[li_16]);
            ObjectSet(l_name_84, OBJPROP_PRICE2, Low[li_12]);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
            ObjectSet(l_name_84, OBJPROP_WIDTH, g_width_148);
         } else ObjectDelete(l_name_84);
         l_name_84 = "HLL_" + ai_0;
         if (HorizontLine && ai_0 + BackStep == 1) {
            ObjectCreate(l_name_84, OBJ_HLINE, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_PRICE1, ld_48);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
         } else ObjectDelete(l_name_84);
         l_name_84 = "LCL_" + ai_0;
         if (ChannelLine) {
            ObjectCreate(l_name_84, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(l_name_84, OBJPROP_TIME1, Time[li_20]);
            ObjectSet(l_name_84, OBJPROP_TIME2, Time[0]);
            ObjectSet(l_name_84, OBJPROP_PRICE1, High[li_20]);
            ObjectSet(l_name_84, OBJPROP_PRICE2, High[li_20] + ld_40 * li_20);
            ObjectSet(l_name_84, OBJPROP_COLOR, g_color_152);
         } else ObjectDelete(l_name_84);
         l_name_84 = "LTL_" + ai_0;
         if (TakeLines) {
            lda_60[3] = ld_48 - High[li_20] + 1.618 * (High[li_20] - Low[li_12]);
            lda_60[0] = High[li_20] - ld_40 * (li_16 - li_20) - Low[li_16];
            lda_60[1] = Close[li_20] - ld_40 * (li_16 - li_20) - Low[li_16];
            li_20 = iHighest(NULL, 0, MODE_CLOSE, li_16 - li_12, li_12);
            lda_60[2] = Close[li_20] - ld_40 * (li_16 - li_20) - Low[li_16];
            ls_ret_68 = ls_ret_68 + "Targets: ";
            for (l_index_24 = 0; l_index_24 < 4; l_index_24++) {
               ld_40 = NormalizeDouble(ld_48 - lda_60[l_index_24], gi_184);
               ObjectCreate(l_name_84 + l_index_24, OBJ_HLINE, 0, 0, 0, 0, 0);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_PRICE1, ld_40);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_STYLE, STYLE_DOT);
               ObjectSet(l_name_84 + l_index_24, OBJPROP_COLOR, g_color_152);
               ls_ret_68 = ls_ret_68 + DoubleToStr(ld_40, gi_184) + " (" + DoubleToStr(lda_60[l_index_24] / Point, 0) + "p.) ";
            }
            ls_ret_68 = ls_ret_68 
            + "\n";
         } else for (l_index_24 = 0; l_index_24 < 4; l_index_24++) ObjectDelete(l_name_84 + l_index_24);
      }
   }
   return (ls_ret_68);
}

int GetTD(int ai_0, double ada_4[]) {
   int l_index_8 = 0;
   for (int l_count_12 = 0; l_count_12 < ai_0; l_count_12++) {
      l_index_8++;
      while (ada_4[l_index_8] == 0.0) {
         l_index_8++;
         if (l_index_8 > showBars - 2) return (-1);
      }
   }
   return (l_index_8);
}

int GetNextHighTD(int ai_0) {
   int li_ret_4 = ai_0 + 1;
   while (g_ibuf_156[li_ret_4] <= High[ai_0]) {
      li_ret_4++;
      if (li_ret_4 > showBars - 2) return (-1);
   }
   return (li_ret_4);
}

int GetNextLowTD(int ai_0) {
   int li_ret_4 = ai_0 + 1;
   while (g_ibuf_160[li_ret_4] >= Low[ai_0] || g_ibuf_160[li_ret_4] == 0.0) {
      li_ret_4++;
      if (li_ret_4 > showBars - 2) return (-1);
   }
   return (li_ret_4);
}

double DemHigh(int ai_0, int ai_4) {
   if (High[ai_0] >= High[ai_0 + ai_4] && High[ai_0] > High[ai_0 - ai_4]) {
      if (ai_4 > 1) return (DemHigh(ai_0, ai_4 - 1));
      else return (High[ai_0]);
   } else return (0);
}

double DemLow(int ai_0, int ai_4) {
   if (Low[ai_0] <= Low[ai_0 + ai_4] && Low[ai_0] < Low[ai_0 - ai_4]) {
      if (ai_4 > 1) return (DemLow(ai_0, ai_4 - 1));
      else return (Low[ai_0]);
   } else return (0);
}

string On(bool ai_0) {
   if (ai_0) return ("on");
   else return ("off");
}

string UpHitch(int ai_0, double ad_4) {
   string ls_ret_12 = "";
   if (Close[ai_0 + 1] < Close[ai_0 + 2]) ls_ret_12 = ls_ret_12 + " 1";
   if (ai_0 >= 0 && Open[ai_0] > ad_4) ls_ret_12 = ls_ret_12 + " 2";
   if (2.0 * (Close[ai_0 + 1]) - (Low[ai_0 + 1]) < ad_4) ls_ret_12 = ls_ret_12 + " 3";
   if (ls_ret_12 != "") ls_ret_12 = "[ Break Qualificator:" + ls_ret_12 + " ]";
   return (ls_ret_12);
}

string DownHitch(int ai_0, double ad_4) {
   string ls_ret_12 = "";
   if (Close[ai_0 + 1] > Close[ai_0 + 2]) ls_ret_12 = ls_ret_12 + " 1";
   if (ai_0 >= 0 && Open[ai_0] < ad_4) ls_ret_12 = ls_ret_12 + " 2";
   if (2.0 * (Close[ai_0 + 1]) - (High[ai_0 + 1]) > ad_4) ls_ret_12 = ls_ret_12 + " 3";
   if (ls_ret_12 != "") ls_ret_12 = "[ Break Qualificator:" + ls_ret_12 + " ]";
   return (ls_ret_12);
}